Unit AFP3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP3R(var A :Array of Real; N :Integer; M :Integer;
                var W :Array of Real; var S :Array of Integer);

implementation

procedure AFP3R(var A :Array of Real; N :Integer; M :Integer;
                var W :Array of Real; var S :Array of Integer);
var
I,J,B,G,H :Integer;
C,D,E,F,K,R,T,BD,BJ :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19;
begin
for B:=1 to N do
 begin
  if ( B <> M ) 
   then goto _1;
  W[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := 0.0;
  goto _19;
_1:
  H := B;
  C := 0.0;
  for I:=B to N do
   begin
    F := 0.0;
    for J:=B to M do
     begin
      T := Abs(A[(I-1)+(J-1)*N]);
      if ( F >= T ) 
       then goto _2;
      F := T;
_2:
     end;
    if ( F = 0.0 ) 
     then goto _4;
    K := 1.0/F;
    D := 0.0;
    for J:=B to M do
     begin
      D := D+A[(I-1)+(J-1)*N]*K*A[(I-1)+(J-1)*N]*K;
_3:
     end;
    F := Sqrt(D)*F;
_4:
    if ( C >= F ) 
     then goto _5;
    C := F;
    H := I;
_5:
   end;
  if ( H = B ) 
   then goto _7;
  for J:=1 to M do
   begin
    BD := A[(H-1)+(J-1)*N];
    A[(H-1)+(J-1)*N] := A[(B-1)+(J-1)*N];
    A[(B-1)+(J-1)*N] := BD;
_6:
   end;
_7:
  S[B-1] := H;
  for J:=B to M do
   begin
    W[J-1] := A[(B-1)+(J-1)*N];
_8:
   end;
  if ( C = 0.0 ) 
   then goto _18;
  R := 1.0/C;
  for J:=B to M do
   begin
    W[J-1] := W[J-1]*R;
_9:
   end;
  if ( W[B-1] <> 0.0 ) 
   then goto _10;
  E := 1.0;
  W[B-1] := 1.0;
  goto _12;
_10:
  E := Sign(1.0,W[B-1]);
  R := 1.0+Abs(W[B-1]);
  W[B-1] := E*R;
  R := 1.0/Sqrt(R);
  for J:=B to M do
   begin
    W[J-1] := W[J-1]*R;
_11:
   end;
_12:
  E := -C*E;
  for J:=B to M do
   begin
    A[(B-1)+(J-1)*N] := W[J-1];
_13:
   end;
  if ( B = N ) 
   then goto _17;
  G := B+1;
  for I:=G to N do
   begin
    BJ := 0.0;
    for J:=B to M do
     begin
      BJ := BJ+A[(I-1)+(J-1)*N]*W[J-1];
_14:
     end;
    for J:=B to M do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-BJ*W[J-1];
_15:
     end;
_16:
   end;
_17:
  W[B-1] := E;
_18:
 end;
_19:
end;

end.
